package com.example.uart2;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.text.SimpleDateFormat;
import java.util.Date;

import android.util.Log;

import com.example.uart2.bean.Uart;




public class MonitorAnalysis_SSTLR{
	
	private byte[] last;

	public String convert(byte[] bs) {
		if(!((bs[0]&0xFF)==255&&(bs[1]&0xFF)==255&&(bs[2]&0xFF)==255&&(bs[3]&0xFF)==255&&(bs[4]&0xFF)==255))return null;
		String s="";
		if((bs[6]&0x7f)==0x03){//温湿度
			s+="卡号"+String.valueOf(getInt(bs[7],bs[8],false));
			s+="，温度"+getFloat(bs[9],bs[10],bs[11],bs[12]);
			s+="，湿度"+getFloat(bs[13],bs[14],bs[15],bs[16]);
			if((bs[6]&0x80)==0x80)s+="电压低";
		}else{
			s="解析失败";
		}
		return s;
	}
	
	public Uart convertArray(byte[] bs,int size) {
		if(size==12){
			last=bs;
			return null;
		}else if(size==6&&last!=null){
			last[12]=bs[0];
			last[13]=bs[1];
			last[14]=bs[2];
			last[15]=bs[3];
			last[16]=bs[4];
			last[17]=bs[5];
			bs=last;
			last=null;
		}
		if(!((bs[0]&0xFF)==255&&(bs[1]&0xFF)==255&&(bs[2]&0xFF)==255&&(bs[3]&0xFF)==255&&(bs[4]&0xFF)==255))return null;
		if((byte)(bs[5]^bs[6]^bs[7]^bs[8]^bs[9]^bs[10]^bs[11]^bs[12]^bs[13]^bs[14]^bs[15]^bs[16])!=bs[17]){
			Log.w("data", "校验错误");
			return null;
		}
		Uart u=new Uart();
		u.setNo(String.valueOf(getInt(bs[7],bs[8],false)));
		u.setTemp(getFloat(bs[9],bs[10],bs[11],bs[12])+"");
		u.setHumi(getFloat(bs[13],bs[14],bs[15],bs[16])+"");
		u.setVoltage((bs[6]&0x80)==0x80?"低":"正常");
		u.setTime(new SimpleDateFormat("hh:mm:ss").format(new Date()));
		u.setType((bs[6]&0x7f)+"");
		return u;
	}
	
	private float getFloat(byte b1,byte b2,byte b3,byte b4){
		byte[] b=new byte[]{b1,b2,b3,b4};
	    ByteBuffer buf=ByteBuffer.allocateDirect(4); //无额外内存的直接缓存
	    buf=buf.order(ByteOrder.LITTLE_ENDIAN);//默认大端，小端用这行
	    buf.put(b);
	    buf.rewind();
	    return ((float)((int)(buf.getFloat()*100)))/100;
	}
	
	public int getInt(byte b1,byte b2,boolean fuhao){
		if(!fuhao)return ((b1&0xFF)<<8)|(b2&0xFF);
		else{
			int b = ((b1&0xFF)<<8)|(b2&0xFF);
			if(b >= 0x8000){
				 //负值
				b = ~b + 1;//取反加1
				b = b & 0xFFFF;//取低2字节
				b *= -1;
			}
			//int v=(((b1&0x7f)<<8)|(b2&0xFF))*((b1 & 0x80)==0?1:-1);
			return b;
		}
	}

}
